#include "stdafx.h"
#include "WallpaperQ.h"
#include "OptionsDialog.h"
#include "MainHelperQ.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(COptionsDialog, CDialog)
COptionsDialog::COptionsDialog(int startup, int thisuser, int exitafter, int usetimer, int minutes, int iupdate, int idisplayclock, int idisplayvisible, int idisplaymonitor, int idisplaytrayme,
							   CWnd * pParent /*=NULL*/) : CDialog(COptionsDialog::IDD, pParent),
							   iStartup(startup),
							   iThisUser(thisuser),
							   iExitAfter(exitafter),
							   iUseTimer(usetimer),
							   iMinutes(minutes),
							   iUpdate(iupdate),
							   iDisplayClock(idisplayclock),
							   iDisplayVisible(idisplayvisible),
							   iDisplayMonitor(idisplaymonitor),
							   iDisplayTrayMe(idisplaytrayme)
{
	iHours = iMinutes / 60;
	iMinutes = iMinutes % 60;
}

COptionsDialog::~COptionsDialog()
{
}

void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STARTUP, m_chkStartup);
	DDX_Control(pDX, IDC_THISUSER, m_radioThisUser);
	DDX_Control(pDX, IDC_ALLUSERS, m_radioAllUsers);
	DDX_Control(pDX, IDC_EXITAFTER, m_chkExitAfter);
	DDX_Control(pDX, IDC_USETIMER, m_chkUseTimer);
	DDX_Control(pDX, IDC_MINUTES, m_editMinutes);
	DDX_Control(pDX, IDC_SPINHOURS, m_spinHours);
	DDX_Control(pDX, IDC_SPINMINUTES, m_spinMinutes);
	DDX_Control(pDX, IDC_HOURS, m_editHours);
	DDX_Control(pDX, IDC_UPDATE, m_chkUpdate);
	DDX_Control(pDX, IDC_DISPLAYCLOCK, m_chkDisplayClock);
	DDX_Control(pDX, IDC_DISPLAYVISIBLE, m_chkDisplayVisible);
	DDX_Control(pDX, IDC_DISPLAYMONITOR, m_chkDisplayMonitor);
	DDX_Control(pDX, IDC_DISPLAYTRAYME, m_chkDisplayTrayMe);
	DDX_Control(pDX, IDC_CHANGELANGUAGE, m_cbxLanguage);
}


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
	ON_BN_CLICKED(IDC_USETIMER, OnBnClickedUsetimer)
	ON_BN_CLICKED(IDC_EXITAFTER, OnBnClickedExitafter)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_STARTUP, OnBnClickedStartup)
END_MESSAGE_MAP()

// COptionsDialog message handlers

BOOL COptionsDialog::OnInitDialog()
{
	CString cstrMinutes, cstrHours;

	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_OPTIONS_DIALOG);
	m_Helper.translateDlgItemText(this, IDC_STARTUP);
	m_Helper.translateDlgItemText(this, IDC_THISUSER);
	m_Helper.translateDlgItemText(this, IDC_ALLUSERS);
	m_Helper.translateDlgItemText(this, IDC_EXITAFTER);
	m_Helper.translateDlgItemText(this, IDC_USETIMER);
	m_Helper.translateDlgItemText(this, IDC_EHOURS);
	m_Helper.translateDlgItemText(this, IDC_EMINUTES);
	m_Helper.translateDlgItemText(this, IDC_UPDATE);
	m_Helper.translateDlgItemText(this, IDC_DISPLAYCLOCK);
	m_Helper.translateDlgItemText(this, IDC_DISPLAYVISIBLE);
	m_Helper.translateDlgItemText(this, IDC_DISPLAYMONITOR);
	m_Helper.translateDlgItemText(this, IDC_DISPLAYTRAYME);
	m_Helper.translateDlgItemText(this, IDOK);
	m_Helper.translateDlgItemText(this, IDCANCEL);
	m_Helper.translateDlgItemText(this, IDC_LLANGUAGE);

	m_chkStartup.SetCheck(iStartup);
	m_radioThisUser.SetCheck(iThisUser);
	m_radioAllUsers.SetCheck(!iThisUser);
	m_chkUpdate.SetCheck(iUpdate);
	m_chkDisplayClock.SetCheck(iDisplayClock);
	m_chkDisplayVisible.SetCheck(iDisplayVisible);
	m_chkDisplayMonitor.SetCheck(iDisplayMonitor);
	m_chkDisplayTrayMe.SetCheck(iDisplayTrayMe);

	if (iStartup == 0)
	{
		m_radioThisUser.EnableWindow(false);
		m_radioAllUsers.EnableWindow(false);
	}

	m_chkExitAfter.SetCheck(iExitAfter);
	m_chkUseTimer.SetCheck(iUseTimer);

	cstrHours.Format("%d", iHours);
	m_editHours.SetWindowText(cstrHours);

	cstrMinutes.Format("%d", iMinutes);
	m_editMinutes.SetWindowText(cstrMinutes);

	OnBnClickedExitafter();

	OnBnClickedUsetimer();

	m_spinHours.SetBuddy((CWnd *)&m_editHours);
	m_spinHours.SetRange(0, 24);

	m_spinMinutes.SetBuddy((CWnd *)&m_editMinutes);
	m_spinMinutes.SetRange(0, 59);

	CFileFind finder;
	TCHAR buffer[MAX_PATH + 1];
	CString directory = "";
	CString name = "";
	CString language = "";

	GetModuleFileName(theApp.m_hInstance, buffer, MAX_PATH);
	directory.Format(_T("%s"), buffer);
	directory = directory.Left(directory.ReverseFind('\\') + 1);
	name.Format(_T("%s"), buffer);
	name = name.Right(name.GetLength() - name.ReverseFind('\\') - 1);
	name = name.Left(name.ReverseFind('.'));

	m_cbxLanguage.AddString(_T("en"));
	BOOL bWorking = finder.FindFile(directory + name + _T("_*.ini"));
	int i = 0;
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		language = finder.GetFilePath();
		language = language.Right(language.GetLength() - language.ReverseFind('_') - 1);
		language = language.Left(language.ReverseFind('.'));
		if (m_cbxLanguage.FindStringExact(0, language) == CB_ERR)
		{
			m_cbxLanguage.AddString(language);
			i++;
		}
		if(language.Compare(Language)==0)
		{
			m_cbxLanguage.SetCurSel(i);
		}
	}
	return true;
}
void COptionsDialog::OnBnClickedUsetimer()
{
	if (m_chkUseTimer.GetCheck() == 0)
	{
		m_editMinutes.EnableWindow(false);
		m_chkExitAfter.EnableWindow();
	}
	else
	{
		m_editMinutes.EnableWindow();
		m_chkExitAfter.SetCheck(0);
		m_chkExitAfter.EnableWindow(false);
	}
}

void COptionsDialog::OnBnClickedStartup()
{
	m_radioThisUser.EnableWindow(m_chkStartup.GetCheck());
	m_radioAllUsers.EnableWindow(m_chkStartup.GetCheck());
}

void COptionsDialog::OnBnClickedExitafter()
{
	if (m_chkExitAfter.GetCheck() == 1)
	{
		m_chkUseTimer.SetCheck(0);
		m_chkUseTimer.EnableWindow(false);
		m_editMinutes.EnableWindow(false);
	}
	else
		m_chkUseTimer.EnableWindow();
}

void COptionsDialog::OnBnClickedOk()
{
	CString cstrMinutes, cstrHours;

	iStartup = m_chkStartup.GetCheck();
	iThisUser = m_radioThisUser.GetCheck();
	iExitAfter = m_chkExitAfter.GetCheck();
	iUseTimer = m_chkUseTimer.GetCheck();

	m_editMinutes.GetWindowText(cstrMinutes);
	m_editHours.GetWindowText(cstrHours);
	iUpdate = m_chkUpdate.GetCheck();
	iDisplayClock = m_chkDisplayClock.GetCheck();
	iDisplayVisible = m_chkDisplayVisible.GetCheck();
	iDisplayMonitor = m_chkDisplayMonitor.GetCheck();
	iDisplayTrayMe = m_chkDisplayTrayMe.GetCheck();

	if (iUseTimer == 1 && cstrMinutes != "")
	{
		iMinutes = atoi(cstrMinutes);
		iHours = atoi(cstrHours);

		iMinutes += (iHours * 60);
	}
	else
		iMinutes = 0;
	CString tmp;

	m_cbxLanguage.GetLBText(m_cbxLanguage.GetCurSel(), tmp);
	Language = tmp;

	OnOK();
}
